#### trial to optimize a short one: 10-fixed version:
short.design  <- matrix(nrow=10,ncol=10,byrow=TRUE,
                       data=c(1,-1,1,-1,0,0,0,0,0,0,
                         1,-1,-1,0,1,0,0,0,0,0,
                         1,-1,1,0,0,-1,0,0,0,0,
                         1,-1,1,0,0,0,-1,0,0,0,
                         1,-1,-1,0,0,0,0,1,0,0,
                         1,-1,1,0,0,0,0,0,-1,0,
                         1,-1,1,0,0,0,0,0,0,-1,
                         1,-1,0,1,-1,0,0,0,0,0,
                         1,-1,0,1,0,-1,0,0,0,0,
                         1,-1,0,1,0,0,-1,0,0,0))
index.short   <- 1:10
results.short <- optimized.MA.design(c.matrix=cmat.E.GE,
                                     c.info=cinfo.E.GE,
                                     init=init.mat,
                                     print.every=1000,
                                     number.units.of.exp=8,
                                     number.total.arrays=16,
                                     fixed.part=short.design,
                                     index.already.compaired=index.short)
output.design(design=results.short$bld,filename = "short-bld",
              cols=c(rep('black',10),rep('red',6)))

############################################################################################
#### trial to reproduce the old 6-fixed-version:
results.6.fixed <- optimized.MA.design()
save.image(file="6.fixed.env")
output.design(design=results.6.fixed$bld,filename = "6fixed-bld")

############################################################################################
#### trial to optimize a 4-fixed version:
old.4.design <- matrix(nrow=4,ncol=10,byrow=TRUE,
                       data=c(1,-1,0,-1,0,1,0,0,0,0,
                              1,-1,-1,0,1,0,0,0,0,0,
                              1,-1,0,0,-1,1,0,0,0,0,
                              1,-1,1,-1,0,0,0,0,0,0))
index.fixed.4 <- c(9,2,14,1)
results.4.fixed <- optimized.MA.design(c.matrix=cmat.E.GE,
                                       c.info=cinfo.E.GE,
                                       init=init.mat,
                                       print.every=1000,
                                       number.units.of.exp=8,
                                       number.total.arrays=16,
                                       fixed.part=old.4.design,
                                       index.already.compaired=index.fixed.4)
save.image(file="4.fixed.env")
output.design(design=results.4.fixed$bld,filename = "4fixed-bld",
              cols=c(rep('black',4),rep('red',12)))

############################################################################################
#### Compare best 6-fixed with best 4-fixed found so far:
designs <- list(fix.4=results.4.fixed$bld,
                fix.6=results.6.fixed$bld)

comp <- designMA(design.list=designs,
                 cmat=cmat.E.GE,
                 cinfo=cinfo.E.GE,
                 type='t')
print(comp)

## -> fixed 4 has not found something better than fixed 6 had before !!


############################################################################################
#### Was passiert, wenn man bestimmte Arrayys weglaesst??
## (1) weglassen von: T2E2 gegen T1E1 und T1E2 gegen T2E1
designs <- list(fix.6=results.6.fixed$bld,small.1=results.6.fixed$bld[-c(7,8),])
comp <- designMA(design.list=designs,
                 cmat=cmat.E.GE,
                 cinfo=cinfo.E.GE,
                 type='t')
print(comp)
## (2) weglassen von: S1E2 gegen T2E1 und S1E1 gegen T2E2 
designs <- list(fix.6=results.6.fixed$bld,small.1=results.6.fixed$bld[-c(9,11),])
comp <- designMA(design.list=designs,
                 cmat=cmat.E.GE,
                 cinfo=cinfo.E.GE,
                 type='t')
print(comp)


############################################################################################
## Ausprobieren aller Kombinationen von 2en zum Weglassen:
library(vsn)

all.poss <- nchoosek(10,2)+6
best <- 1
for(i in 1:ncol(all.poss)){
  best.design <- results.6.fixed$bld[-all.poss[,best],]
  test.design <- results.6.fixed$bld[-all.poss[,i],]
  comp <- designMA(design.list=list(best=best.design,test=test.design),
                   cmat=cmat.E.GE,
                   cinfo=cinfo.E.GE,
                   type='t')
  if(comp$effdesign=="test") best <- i
}
print(paste("am besten wegzulassen:",all.poss[,best]))
## also tatsaechlich 9 und 11 !

############################################################################################
## Vergleich mit 6-fixed + 8 optimal design:
results.6.fixed.14.total <- optimized.MA.design(c.matrix=cmat.E.GE,
                                                c.info=cinfo.E.GE,
                                                init=init.mat,
                                                print.every=1000,
                                                number.units.of.exp=8,
                                                number.total.arrays=14)
save.image(file="4.fixed.14.total.env")
output.design(design=results.6.fixed.14.total$bld,filename = "6fixed14total-bld",
              cols=c(rep('black',6),rep('red',8)))

## also wird auch hier wieder dasselbe optimale Design fuer 8 freie (14 total)
## gefunden!
## Also koennen diese beiden bis zum Schluss warten!

## Vergleich mit dem tatsaechlich durchgefuehrten Design:
#"IRE1","IRE2","NBE1","NBE2","LCE1","LCE2","TPE1","TPE2"
#NBE2 -> NBE1 [ color= black];OK
#IRE1 -> IRE2 [ color= black];OK
#IRE1 -> NBE2 [ color= black];OK
#IRE2 -> NBE1 [ color= black];OK
#NBE1 -> IRE1 [ color= black];OK
#NBE2 -> IRE2 [ color= black];OK
#LCE1 -> TPE2 [ color= red  ];OK
#TPE2 -> TPE1 [ color= red  ];OK
#TPE1 -> NBE2 [ color= red  ];OK
#IRE2 -> LCE1 [ color= red  ];OK
#NBE1 -> TPE2 [ color= red  ];OK
#LCE2 -> IRE1 [ color= red  ];OK
#LCE2 -> LCE1 [ color= red  ];OK
#TPE1 -> LCE2 [ color= red  ];OK

prakt <- matrix(nrow=14,ncol=10,byrow=TRUE,
                data=c(1,-1,0,0,-1,1,0,0,0,0,
                  1,-1,1,-1,0,0,0,0,0,0,
                  1,-1,1,0,0,-1,0,0,0,0,
                  1,-1,0,1,-1,0,0,0,0,0,
                  1,-1,-1,0,1,0,0,0,0,0,
                  1,-1,0,-1,0,1,0,0,0,0,
                  1,-1,0,0,0,0,1,0,0,-1,
                  1,-1,0,0,0,0,0,0,-1,1,
                  1,-1,0,0,0,-1,0,0,1,0,
                  1,-1,0,1,0,0,-1,0,0,0,
                  1,-1,0,0,1,0,0,0,0,-1,
                  1,-1,-1,0,0,0,0,1,0,0,
                  1,-1,0,0,0,0,-1,1,0,0,
                  1,-1,0,0,0,0,0,-1,1,0))
designs <- list(theo=results.6.fixed.14.total$bld,
                prakt=prakt)
comp <- designMA(design.list=designs,
                 cmat=cmat.E.GE,
                 cinfo=cinfo.E.GE,
                 type='t')##t
print(comp)

#$alleff
#       theo    prakt
#C1 6.000000 6.000000
#C2 3.652174 3.473684
#
#$alleffrel
#   theo     prakt
#C1    1 1.0000000
#C2    1 0.9511278
#
#$alleffave
#    theo    prakt
#1.000000 0.975564
#
#$effdesign
#[1] "theo"
#
#$df
#     theo prakt
#[1,]    6     6

## Sprich: Das von Thomas letztendlich durchgefuehrte Design ist noch gut 2% schlechter
##         als das theoretisch von mir vorgeschlagene...
## Wenn man allerdings das Kriterium "e" verwendet, ist nach Rundung kein Unterschied
## mehr festzustellen... 

save.image("Vergleich-theo-prakt.Rdata")
